#include "generic.h"
// #define type <type of array>
// #define type_null <value to return for empty array>

#define Before TEMPLATE(Type,Before)
void Before(Type **arr,int offset,Type entry);
#define Push TEMPLATE(Type,Push)
static inline void Push(Type **arr,Type entry) {
  Before(arr,0,entry);
}
#define After TEMPLATE(Type,After)
void After(Type **arr,int offset,Type entry);
#define Queue TEMPLATE(Type,Queue)
static inline void Queue(Type **arr,Type entry) {
  After(arr,ArrayLen0(arr[0])-1,entry);
}
#define Delete TEMPLATE(Type,Delete)
Type Delete(Type **arr,int offset,int count);
#define Pop TEMPLATE(Type,Pop)
static inline Type Pop(Type **arr) {
  return Delete(arr,0,1);
}
#define Pull TEMPLATE(Type,Pull)
static inline Type Pull(Type **arr) {
  return Delete(arr,-1,1);
}
// ForEach == Find using a generalize function for Compare
#define FindLinear TEMPLATE(Type,FindLinear)
Type *FindLinear(Type *arr,Type value,int (*Compare)(Type,Type));
#define Next TEMPLATE(Type,Next)
Type *Next(Type *arr,Type *value);
#define Prev TEMPLATE(Type,Prev)
Type *Prev(Type *arr,Type *value);

// FindClosestBinary - same as FindBinary but if no match returns closest
//   match, where element should be inserted before
// note: if element should be inserted at end, this is returning an element
// of the array that is actually invalid!
#define FindClosestBinary TEMPLATE(Type,FindClosestBinary)
Type *FindClosestBinary(Type *arr,Type value,int (*Compare)(Type,Type));
// FindBinary - binary search assuming data sorted by comparison function
#define FindBinary TEMPLATE(Type,FindBinary)
Type *FindBinary(Type *arr,Type value,int (*Compare)(Type,Type));

// InsertSorted - add element to array, sorted into position
#define InsertSorted TEMPLATE(Type,InsertSorted)
int InsertSorted(Type **arr,Type entry,int (*Compare)(Type,Type));

#define ReplaceSorted TEMPLATE(Type,ReplaceSorted)
Type ReplaceSorted(Type **arr,Type entry,int (*Compare)(Type,Type));

#undef Before
#undef Push
#undef After
#undef Queue
#undef Delete
#undef Pop
#undef Pull
#undef Next
#undef Prev
#undef FindLinear
#undef FindBinary
#undef FindClosestBinary
#undef InsertSorted
#undef ReplaceSorted
/*
  Author: Michael Schmidt (michael@embeddedARM.com)
 */
